# Gemini 3 Pro Image Preview · Edit API

> Gemini 3 Pro Image rediģēšana no atsauces attēliem ar 1K līdz 4K izvadi un tīmekļa meklēšanas opciju

Rediģē vai apvieno attēlus no `image_urls` (obligāts) atbilstoši `prompt`. `aspect_ratio` pēc noklusējuma ir auto, `resolution` var būt 1K, 2K vai 4K, kā arī var iespējot `system_prompt` un tīmekļa meklēšanu. Atgriež 1 līdz 4 rediģētus attēlus PNG, JPEG vai WebP formātā.

- Model id: `gemini-3-pro-image-preview/edit`
- Made by: Google
- Category: Image Editing
- Output: image
- Price: from $0.15 / image (cheapest run $0.15 (150 API credits))
- Run: `POST https://api.doitong.com/v1/run/gemini-3-pro-image-preview/edit`
- Quote: `POST https://api.doitong.com/v1/quote/gemini-3-pro-image-preview/edit`
- Docs page: https://doitong.com/lv/developers/models/gemini-3-pro-image-preview/edit

## Pricing

Price: **from $0.15 / image** (the lowest tier; the quote prices your exact input). Billed per generated image (`num_images`, default 1).

Price rules (the first rule that matches the input wins; a parameter you leave out counts as its default):

- When `resolution` = 4K: $0.30 (300 API credits) / image

The full example input below costs $0.15 = 150 API credits (1 image × 150 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/gemini-3-pro-image-preview/edit` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  | 3 – 50000 characters | Teksta norādes attēla rediģēšanai. |
| `num_images` | `num_outputs` | integer | no | `1` | 1 – 4 | Ģenerēšanai pieprasītais attēlu skaits. |
| `seed` |  | integer \| null | no |  |  | Sākumvērtība, kas inicializē nejaušo skaitļu ģenerēšanu. |
| `aspect_ratio` |  | enum (string) \| null | no | `auto` | `auto`, `21:9`, `16:9`, `3:2`, `4:3`, `5:4`, `1:1`, `4:5`, `3:4`, `2:3`, `9:16` | Iegūstamā attēla malu attiecība. |
| `output_format` |  | enum (string) | no | `png` | `jpeg`, `png`, `webp` | Iegūtā attēla faila formāts. |
| `safety_tolerance` |  | enum (string) | no | `4` | `1`, `2`, `3`, `4`, `5`, `6` | Iestatiet satura moderēšanas toleranci no vismazāk ierobežojošā līmeņa 6 līdz stingrākajam līmenim 1, kas bloķē lielāko daļu satura. |
| `image_urls` | `images` | array of image URL | yes |  |  | URL, kas identificē avota attēlus rediģēšanai vai image-to-image ģenerēšanai. |
| `system_prompt` |  | string | no | `` | ≤ 50000 characters | Neobligātas visam pieprasījumam piemērojamas personības un izvades stila norādes, kas Gemini tiek nodotas kā sistēmas instrukcija vai ar OpenAI saderīgiem nodrošinātājiem kā sistēmas ziņojums. Ja vērtība ir tukša, šai instrukcijai nekas netiek nosūtīts. |
| `resolution` |  | enum (string) | no | `1K` | `1K`, `2K`, `4K` | Izvades attēla izšķirtspēja. |
| `limit_generations` |  | boolean | no | `true` |  | Eksperimentāls ģenerēšanas ierobežojums: aktivizējot `True`, tiek ignorētas visas attēlu skaita norādes uzvednē un katra uzvednes kārta tiek ierobežota līdz 1 ģenerēšanai. |
| `enable_web_search` |  | boolean | no | `false` |  | Tīmekļa meklēšanas pārslēgs attēla ģenerēšanai, kas ļauj modelim attēlā iekļaut aktuālu tiešsaistē atrastu informāciju. |

File parameters (`images`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
  "images": [
    "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  ]
}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
  "image_urls": [
    "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  ]
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/gemini-3-pro-image-preview/edit?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "image_urls": [
      "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
    ]
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/gemini-3-pro-image-preview/edit?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "image_urls": [
      "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
    ]
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "image_urls": [
        "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg",
    ],
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/gemini-3-pro-image-preview/edit", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "gemini-3-pro-image-preview/edit",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
        "image_urls": [
          "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
        ]
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "gemini-3-pro-image-preview/edit",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 150,
    "usd": "0.15",
    "charged": 150,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "image_urls": [
      "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
    ]
  },
  "output": {
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ],
    "description": "string"
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `images` | array of object {url, content_type, file_name, file_size, width, height} | Rediģēšanas rezultātā iegūtie attēli. |
| `description` | string | Ģenerētajiem attēliem pievienotais apraksts. |

## Related models

- [Gemini 3 Pro Image Preview](https://doitong.com/developers/models/gemini-3-pro-image-preview.md) (`gemini-3-pro-image-preview`): from $0.15 / image
- [Nano Banana 2 Edit](https://doitong.com/developers/models/nano-banana-2/edit.md) (`nano-banana-2/edit`): from $0.06 / image
- [Nano Banana Pro Edit](https://doitong.com/developers/models/nano-banana-pro/edit.md) (`nano-banana-pro/edit`): from $0.15 / image
- [FLUX.1 Kontext \[pro\]](https://doitong.com/developers/models/flux-pro/kontext.md) (`flux-pro/kontext`): $0.04 / image
- [GPT Image 2.5 Edit](https://doitong.com/developers/models/openai/gpt-image-2.5/flare/edit.md) (`openai/gpt-image-2.5/flare/edit`): from $0.12 / image
- [Qwen Image 3 Edit](https://doitong.com/developers/models/alibaba/qwen-image-3/edit.md) (`alibaba/qwen-image-3/edit`): from $0.04 / image
- [Seedream 5.0 Pro Edit](https://doitong.com/developers/models/bytedance/seedream/v5/pro/edit.md) (`bytedance/seedream/v5/pro/edit`): from $0.0675 / run of output image
- [Gemini 2.5 Flash Image · Edit](https://doitong.com/developers/models/gemini-25-flash-image/edit.md) (`gemini-25-flash-image/edit`): $0.0398 / image

## Links

- HTML page: https://doitong.com/developers/models/gemini-3-pro-image-preview/edit
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=gemini-3-pro-image-preview/edit
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/gemini-3-pro-image-preview/edit
